package ru.ifmo.hydro;
/**
  * This file was generated from model [Model1] on [Sat Sep 09 14:37:26 MSD 2006].
  * Do not change content of this file.
  */

import java.util.*;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;


public class Model1EventProcessor extends AbstractEventProcessor {

    private ModelStructure modelStructure;

                private static final int A1 = 1;
    
    private int decodeStateMachine(String sm) {
                    
        if ("A1".equals(sm)) {
            return A1;
            }

        return -1;
    }
        
            private A1EventProcessor _A1;
        
    public Model1EventProcessor() {
        modelStructure = new Model1ModelStructure();

                    _A1 = new A1EventProcessor();
            }

    public ModelStructure getModelStructure() {
        return modelStructure;
    }   
    
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
        
                    _A1.init(controlledObjectsMap);
            }

    protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());
        
        try {
        switch (sm) {
                    case A1:
                return _A1.process(event, context, path, config);
                    default:
                throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
        }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw (SystemException)e;
            } else {
                throw new SystemException(e);
            }
        }
    }

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());

        try {
        switch (sm) {
                    case A1:
                return _A1.transiteToStableState(context, path, config);
                    default:
                throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
        }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw (SystemException)e;
            } else {
                throw new SystemException(e);
            }
        }
    }   

    private class Model1ModelStructure implements ModelStructure {

    private Map configManagers = new HashMap();

    private Model1ModelStructure() {
                    configManagers.put("A1", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
            }

    public StateMachinePath getRootPath() throws EventProcessorException {
        return new StateMachinePath("A1");              
    }

    public StateMachineConfigManager getConfigManager(String stateMachine) throws EventProcessorException {
        return (StateMachineConfigManager)configManagers.get(stateMachine);
    }

    public StateMachineConfig getTopConfig(String stateMachine) throws EventProcessorException {
        int sm = decodeStateMachine(stateMachine);
        
        switch (sm) {
                    case A1:
                return new StateMachineConfig("Top");
                    default:
                throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
        }
    }

    public boolean isFinal(String stateMachine, StateMachineConfig config) throws EventProcessorException {
        // get state machine from path
        int sm = decodeStateMachine(stateMachine);
        int state;
        
        switch (sm) {
                    case A1:
                state = _A1.decodeState(config.getActiveState());
                switch (state) {
                                                                                                                                                                                                                                                                                                                                        case A1EventProcessor.s2:
                                                                                                                                                                                        return true;
                                    default:
                        return false;
                }
                    default:
                throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
        }
    }           
}   
            







private class A1EventProcessor {

        // states
        private static final int Top = 1;
        private static final int Reverse = 2;
        private static final int Neutral = 3;
        private static final int s1 = 4;
        private static final int Gear4 = 5;
        private static final int Gear2 = 6;
        private static final int Gear3 = 7;
        private static final int s2 = 8;
        private static final int Sleep = 9;
        private static final int Gear5 = 10;
        private static final int Gear1 = 11;
    
    private int decodeState(String state) {
                    
        if ("Top".equals(state)) {
            return Top;
                        } else 
                
        if ("Reverse".equals(state)) {
            return Reverse;
                        } else 
                
        if ("Neutral".equals(state)) {
            return Neutral;
                        } else 
                
        if ("s1".equals(state)) {
            return s1;
                        } else 
                
        if ("Gear4".equals(state)) {
            return Gear4;
                        } else 
                
        if ("Gear2".equals(state)) {
            return Gear2;
                        } else 
                
        if ("Gear3".equals(state)) {
            return Gear3;
                        } else 
                
        if ("s2".equals(state)) {
            return s2;
                        } else 
                
        if ("Sleep".equals(state)) {
            return Sleep;
                        } else 
                
        if ("Gear5".equals(state)) {
            return Gear5;
                        } else 
                
        if ("Gear1".equals(state)) {
            return Gear1;
            }
        
        return -1;
    }
    
        // events
        private static final int e4 = 1;
        private static final int e2 = 2;
        private static final int e7 = 3;
        private static final int e5 = 4;
        private static final int e1 = 5;
        private static final int e3 = 6;
        private static final int e6 = 7;
    
    private int decodeEvent(String event) {
                    
        if ("e4".equals(event)) {
            return e4;
                        } else 
                
        if ("e2".equals(event)) {
            return e2;
                        } else 
                
        if ("e7".equals(event)) {
            return e7;
                        } else 
                
        if ("e5".equals(event)) {
            return e5;
                        } else 
                
        if ("e1".equals(event)) {
            return e1;
                        } else 
                
        if ("e3".equals(event)) {
            return e3;
                        } else 
                
        if ("e6".equals(event)) {
            return e6;
                }
    
        return -1;
    }
        
                            private ru.ifmo.hydro.Hydro o1;
                
    private void init(ControlledObjectsMap controlledObjectsMap) {
                                    o1 = (ru.ifmo.hydro.Hydro)controlledObjectsMap.getControlledObject("o1");
                        }
        
    private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
        config = lookForTransition(event, context, path, config);
        
        config = transiteToStableState(context, path, config);
        
        // execute included state machines
        executeSubmachines(event, context, path, config);
        
        return config;
    }
    
    private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
        int state = decodeState(config.getActiveState());
        
        while (true) {
        switch (state) {
                                                                            case Reverse: 
                    
                                            return;
                                                                                    case Neutral: 
                    
                                            return;
                                                                                    case s1: 
                    
                                            return;
                                                                                    case Gear4: 
                    
                                            return;
                                                                                    case Gear2: 
                    
                                            return;
                                                                                    case Gear3: 
                    
                                            return;
                                                                                    case s2: 
                    
                                            return;
                                                                                    case Sleep: 
                    
                                            return;
                                                                                    case Gear5: 
                    
                                            return;
                                                                                    case Gear1: 
                    
                                            return;
                                                                default:
                    throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A1]");
        }
        }
    }
    
    private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

        int s = decodeState(config.getActiveState());
        Event event;

        switch (s) {
                                    case Top:
                    
                                        
                    fireComeToState(context, path, "s1");

                    // s1->Sleep [true]/
                    event = Event.NO_EVENT;
                        fireTransitionFound(context, path, "s1", event, "s1#Sleep##true");
    
        
    fireComeToState(context, path, "Sleep");
    
    // Sleep []
                        
                                            return new StateMachineConfig("Sleep");
                                                                                                                                                                                                                                                        }
    
        return config;
    }    
    
    private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
                    
        
                
        
    
                BitSet calculatedInputActions = new BitSet(0);
        
        int s = decodeState(config.getActiveState());
        int e = decodeEvent(event.getName());
    
        while (true) {
            switch (s) {
                                                                            case Reverse:
                        
                                            
                                                switch (e) {
                                                    case e5:
                                                                
                        // Reverse->Neutral e5[true]/
            
            fireTransitionCandidate(context, path, "Reverse", event, "Reverse#Neutral#e5#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Reverse", event, "Reverse#Neutral#e5#true");
    
        
    fireComeToState(context, path, "Neutral");
    
    // Neutral [o1.z1]
                fireBeforeOutputActionExecution(context, path, "Reverse#Neutral#e5#true", "o1.z1");

                o1.z1(context);
        
    fireAfterOutputActionExecution(context, path, "Reverse#Neutral#e5#true", "o1.z1");
                    return new StateMachineConfig("Neutral");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                        case Neutral:
                        
                                            
                                                switch (e) {
                                                    case e4:
                                                                
                        // Neutral->Reverse e4[true]/
            
            fireTransitionCandidate(context, path, "Neutral", event, "Neutral#Reverse#e4#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Neutral", event, "Neutral#Reverse#e4#true");
    
        
    fireComeToState(context, path, "Reverse");
    
    // Reverse [o1.z8]
                fireBeforeOutputActionExecution(context, path, "Neutral#Reverse#e4#true", "o1.z8");

                o1.z8(context);
        
    fireAfterOutputActionExecution(context, path, "Neutral#Reverse#e4#true", "o1.z8");
                    return new StateMachineConfig("Reverse");

                                                                                
                                                        case e3:
                                                                
                        // Neutral->Gear1 e3[true]/
            
            fireTransitionCandidate(context, path, "Neutral", event, "Neutral#Gear1#e3#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Neutral", event, "Neutral#Gear1#e3#true");
    
        
    fireComeToState(context, path, "Gear1");
    
    // Gear1 [o1.z3]
                fireBeforeOutputActionExecution(context, path, "Neutral#Gear1#e3#true", "o1.z3");

                o1.z3(context);
        
    fireAfterOutputActionExecution(context, path, "Neutral#Gear1#e3#true", "o1.z3");
                    return new StateMachineConfig("Gear1");

                                                                                
                                                        case e6:
                                                                
                        // Neutral->s2 e6[true]/o1.z2
            
            fireTransitionCandidate(context, path, "Neutral", event, "Neutral#s2#e6#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Neutral", event, "Neutral#s2#e6#true");
    
                fireBeforeOutputActionExecution(context, path, "Neutral#s2#e6#true", "o1.z2");

                o1.z2(context);
        
    fireAfterOutputActionExecution(context, path, "Neutral#s2#e6#true", "o1.z2");
        
    fireComeToState(context, path, "s2");
    
    // s2 []
                    return new StateMachineConfig("s2");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                                                    case Gear4:
                        
                                            
                                                switch (e) {
                                                    case e2:
                                                                
                        // Gear4->Gear3 e2[true]/o1.z10
            
            fireTransitionCandidate(context, path, "Gear4", event, "Gear4#Gear3#e2#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear4", event, "Gear4#Gear3#e2#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear4#Gear3#e2#true", "o1.z10");

                o1.z10(context);
        
    fireAfterOutputActionExecution(context, path, "Gear4#Gear3#e2#true", "o1.z10");
        
    fireComeToState(context, path, "Gear3");
    
    // Gear3 [o1.z5]
                fireBeforeOutputActionExecution(context, path, "Gear4#Gear3#e2#true", "o1.z5");

                o1.z5(context);
        
    fireAfterOutputActionExecution(context, path, "Gear4#Gear3#e2#true", "o1.z5");
                    return new StateMachineConfig("Gear3");

                                                                                
                                                        case e1:
                                                                
                        // Gear4->Gear5 e1[true]/o1.z9
            
            fireTransitionCandidate(context, path, "Gear4", event, "Gear4#Gear5#e1#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear4", event, "Gear4#Gear5#e1#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear4#Gear5#e1#true", "o1.z9");

                o1.z9(context);
        
    fireAfterOutputActionExecution(context, path, "Gear4#Gear5#e1#true", "o1.z9");
        
    fireComeToState(context, path, "Gear5");
    
    // Gear5 [o1.z7]
                fireBeforeOutputActionExecution(context, path, "Gear4#Gear5#e1#true", "o1.z7");

                o1.z7(context);
        
    fireAfterOutputActionExecution(context, path, "Gear4#Gear5#e1#true", "o1.z7");
                    return new StateMachineConfig("Gear5");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                        case Gear2:
                        
                                            
                                                switch (e) {
                                                    case e2:
                                                                
                        // Gear2->Gear1 e2[true]/o1.z10
            
            fireTransitionCandidate(context, path, "Gear2", event, "Gear2#Gear1#e2#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear2", event, "Gear2#Gear1#e2#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear2#Gear1#e2#true", "o1.z10");

                o1.z10(context);
        
    fireAfterOutputActionExecution(context, path, "Gear2#Gear1#e2#true", "o1.z10");
        
    fireComeToState(context, path, "Gear1");
    
    // Gear1 [o1.z3]
                fireBeforeOutputActionExecution(context, path, "Gear2#Gear1#e2#true", "o1.z3");

                o1.z3(context);
        
    fireAfterOutputActionExecution(context, path, "Gear2#Gear1#e2#true", "o1.z3");
                    return new StateMachineConfig("Gear1");

                                                                                
                                                        case e1:
                                                                
                        // Gear2->Gear3 e1[true]/o1.z9
            
            fireTransitionCandidate(context, path, "Gear2", event, "Gear2#Gear3#e1#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear2", event, "Gear2#Gear3#e1#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear2#Gear3#e1#true", "o1.z9");

                o1.z9(context);
        
    fireAfterOutputActionExecution(context, path, "Gear2#Gear3#e1#true", "o1.z9");
        
    fireComeToState(context, path, "Gear3");
    
    // Gear3 [o1.z5]
                fireBeforeOutputActionExecution(context, path, "Gear2#Gear3#e1#true", "o1.z5");

                o1.z5(context);
        
    fireAfterOutputActionExecution(context, path, "Gear2#Gear3#e1#true", "o1.z5");
                    return new StateMachineConfig("Gear3");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                        case Gear3:
                        
                                            
                                                switch (e) {
                                                    case e2:
                                                                
                        // Gear3->Gear2 e2[true]/o1.z10
            
            fireTransitionCandidate(context, path, "Gear3", event, "Gear3#Gear2#e2#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear3", event, "Gear3#Gear2#e2#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear3#Gear2#e2#true", "o1.z10");

                o1.z10(context);
        
    fireAfterOutputActionExecution(context, path, "Gear3#Gear2#e2#true", "o1.z10");
        
    fireComeToState(context, path, "Gear2");
    
    // Gear2 [o1.z4]
                fireBeforeOutputActionExecution(context, path, "Gear3#Gear2#e2#true", "o1.z4");

                o1.z4(context);
        
    fireAfterOutputActionExecution(context, path, "Gear3#Gear2#e2#true", "o1.z4");
                    return new StateMachineConfig("Gear2");

                                                                                
                                                        case e1:
                                                                
                        // Gear3->Gear4 e1[true]/o1.z9
            
            fireTransitionCandidate(context, path, "Gear3", event, "Gear3#Gear4#e1#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear3", event, "Gear3#Gear4#e1#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear3#Gear4#e1#true", "o1.z9");

                o1.z9(context);
        
    fireAfterOutputActionExecution(context, path, "Gear3#Gear4#e1#true", "o1.z9");
        
    fireComeToState(context, path, "Gear4");
    
    // Gear4 [o1.z6]
                fireBeforeOutputActionExecution(context, path, "Gear3#Gear4#e1#true", "o1.z6");

                o1.z6(context);
        
    fireAfterOutputActionExecution(context, path, "Gear3#Gear4#e1#true", "o1.z6");
                    return new StateMachineConfig("Gear4");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                                                    case Sleep:
                        
                                            
                                                switch (e) {
                                                    case e7:
                                                                
                        // Sleep->Neutral e7[true]/
            
            fireTransitionCandidate(context, path, "Sleep", event, "Sleep#Neutral#e7#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Sleep", event, "Sleep#Neutral#e7#true");
    
        
    fireComeToState(context, path, "Neutral");
    
    // Neutral [o1.z1]
                fireBeforeOutputActionExecution(context, path, "Sleep#Neutral#e7#true", "o1.z1");

                o1.z1(context);
        
    fireAfterOutputActionExecution(context, path, "Sleep#Neutral#e7#true", "o1.z1");
                    return new StateMachineConfig("Neutral");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                        case Gear5:
                        
                                            
                                                switch (e) {
                                                    case e2:
                                                                
                        // Gear5->Gear4 e2[true]/o1.z10
            
            fireTransitionCandidate(context, path, "Gear5", event, "Gear5#Gear4#e2#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear5", event, "Gear5#Gear4#e2#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear5#Gear4#e2#true", "o1.z10");

                o1.z10(context);
        
    fireAfterOutputActionExecution(context, path, "Gear5#Gear4#e2#true", "o1.z10");
        
    fireComeToState(context, path, "Gear4");
    
    // Gear4 [o1.z6]
                fireBeforeOutputActionExecution(context, path, "Gear5#Gear4#e2#true", "o1.z6");

                o1.z6(context);
        
    fireAfterOutputActionExecution(context, path, "Gear5#Gear4#e2#true", "o1.z6");
                    return new StateMachineConfig("Gear4");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                                        case Gear1:
                        
                                            
                                                switch (e) {
                                                    case e5:
                                                                
                        // Gear1->Neutral e5[true]/
            
            fireTransitionCandidate(context, path, "Gear1", event, "Gear1#Neutral#e5#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear1", event, "Gear1#Neutral#e5#true");
    
        
    fireComeToState(context, path, "Neutral");
    
    // Neutral [o1.z1]
                fireBeforeOutputActionExecution(context, path, "Gear1#Neutral#e5#true", "o1.z1");

                o1.z1(context);
        
    fireAfterOutputActionExecution(context, path, "Gear1#Neutral#e5#true", "o1.z1");
                    return new StateMachineConfig("Neutral");

                                                                                
                                                        case e1:
                                                                
                        // Gear1->Gear2 e1[true]/o1.z9
            
            fireTransitionCandidate(context, path, "Gear1", event, "Gear1#Gear2#e1#true");
            
                        
                            
            
                            
                    fireTransitionFound(context, path, "Gear1", event, "Gear1#Gear2#e1#true");
    
                fireBeforeOutputActionExecution(context, path, "Gear1#Gear2#e1#true", "o1.z9");

                o1.z9(context);
        
    fireAfterOutputActionExecution(context, path, "Gear1#Gear2#e1#true", "o1.z9");
        
    fireComeToState(context, path, "Gear2");
    
    // Gear2 [o1.z4]
                fireBeforeOutputActionExecution(context, path, "Gear1#Gear2#e1#true", "o1.z4");

                o1.z4(context);
        
    fireAfterOutputActionExecution(context, path, "Gear1#Gear2#e1#true", "o1.z4");
                    return new StateMachineConfig("Gear2");

                                                                                
                                                    default:
                                                        
                            
                                        // transition not found
                                return config;
                                                }
                        
                                                                    default:
                    throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A1]");
            }
        }
    }

                
}
    
    private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
        boolean b = calculatedInputActions.get(k);
            
        if (!b) {
            calculatedInputActions.set(k);
        }
            
        return b;
    }
    
}
    
