package ru.ifmo.hydro;

import javax.swing.*;
import java.awt.*;

/**
 * Created by Andrey Vokin.
 * User: admin
 * Date: 28.12.2005
 * Time: 1:00:40
 */
public class TachometerPanel extends JPanel {

	public static final long serialVersionUID = 123456789056l;
	
    public static final int RADIUS_X = 50;
    public static final int RADIUS_Y = 50;
    public static final int CENTER_X = 125;
    public static final int CENTER_Y = 90;
    public static final int ARROW_RADIUS = 15;
    public static final int ARROW_ANGLE = 15;
    
    public static final String ROTATIONS = "";
    public static final String GEAR = "";

    /**
     * Maximal value of the engine rotations.
     */
    public static final int MAX_ROTATIONS = 3000;

    private JLabel lblRotations;

    private int rotations;

    private int gear;

    public TachometerPanel() {
        super();

        lblRotations = new JLabel();
        add(lblRotations);
    }

    public void drawLine(Graphics g, double angle) {
        int y = CENTER_Y - (int) (Math.sin(Math.PI * angle / 180) * RADIUS_Y);
        int x = CENTER_X - (int) (Math.cos(Math.PI * angle / 180) * RADIUS_X);
        
        double beta = angle - ARROW_ANGLE; 
        int x2 = x - (int) (Math.cos(Math.PI * (180 - beta) / 180) * ARROW_RADIUS);
        int y2 = y + (int) (Math.sin(Math.PI * (180 - beta) / 180) * ARROW_RADIUS);
        
        double gamma = angle + ARROW_ANGLE;
        int x3 = x - (int) (Math.cos(Math.PI * (180 - gamma) / 180) * ARROW_RADIUS);
        int y3 = y + (int) (Math.sin(Math.PI * (180 - gamma) / 180) * ARROW_RADIUS);
         
        g.drawLine (x, y, x2, y2);
        g.drawLine (x, y, x3, y3);                
        g.drawLine(CENTER_X, CENTER_Y, x, y);
    }

    public void paint(Graphics g) {
        super.paint(g);
        double angle = 1.0 * rotations / MAX_ROTATIONS * 180;
        g.drawArc(CENTER_X - RADIUS_X, CENTER_Y - RADIUS_Y, 2 * RADIUS_X, 2 * RADIUS_Y, 0, 180);
        drawLine(g, angle);
        g.drawOval(200, 150, 2, 2);
    }

    private void write() {
    	String sGear = "" + gear;
    	if (gear == 0) {
    		sGear = "";
    	} else if (gear == -1) {
    		sGear = "R";
    	}
        lblRotations.setText(ROTATIONS + ": " + rotations + ", " + GEAR + ": " + sGear);
    }

    public void setRotations(int rotations) {
        this.rotations = rotations;
        write();
    }

    public void setGear(int gear) {
        this.gear = gear;
        write();
    }
}